"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const no_enums_1 = __importDefault(require("./no-enums"));
const utils_1 = require("@typescript-eslint/utils");
const utils_2 = require("@typescript-eslint/utils");
// eslint-disable-next-line functional/prefer-immutable-types
const ruleTester = new utils_2.ESLintUtils.RuleTester({
    parserOptions: {
        sourceType: "module",
        project: "./tsconfig.tests.json",
    },
    parser: "@typescript-eslint/parser",
});
// eslint-disable-next-line functional/no-expression-statements
ruleTester.run("no-enums", no_enums_1.default, {
    valid: [],
    invalid: [
        {
            filename: "file.ts",
            code: `
        enum ZeroOrOne {
          Zero = 0,
          One = 1,
        }
      `,
            errors: [
                {
                    messageId: "errorStringGeneric",
                    type: utils_1.AST_NODE_TYPES.TSEnumDeclaration,
                },
            ],
        },
        {
            filename: "file.ts",
            code: `
        enum ZeroOrOne {
          Zero,
          One,
        }
      `,
            errors: [
                {
                    messageId: "errorStringGeneric",
                    type: utils_1.AST_NODE_TYPES.TSEnumDeclaration,
                },
            ],
        },
        {
            filename: "file.ts",
            code: `
        enum AOrB {
          A = "A",
          B = "B",
        }
      `,
            errors: [
                {
                    messageId: "errorStringGeneric",
                    type: utils_1.AST_NODE_TYPES.TSEnumDeclaration,
                },
            ],
        },
    ],
});
